#ifndef PREDICATE_H
#define PREDICATE_H

class Point;


enum SIGN {
  NEGATIVE = -1,
  ZERO = 0,
  POSITIVE = 1
};



class Predicate
{

public:  

  static SIGN myorient2d( Point* _p1, Point* _p2, Point* _p3 );

  static bool isLeftSide(Point* _p1, Point* _p2, Point* _p3) {
    return myorient2d(_p1,_p2,_p3) == POSITIVE;
  };

  static bool areColinear(Point* _p1, Point* _p2, Point* _p3) {
    return myorient2d(_p1,_p2,_p3) == ZERO;
  };

  static bool isRightSide(Point* _p1, Point* _p2, Point* _p3) {
    return myorient2d(_p1,_p2,_p3) == NEGATIVE;
  };

  static bool isRightSideAndContains(Point* _p1, Point* _p2, Point* _p3) {
    return (myorient2d(_p1,_p2,_p3) == NEGATIVE || myorient2d(_p1,_p2,_p3) == ZERO);
  };


private:



};


#endif // PREDICATE_H
