#ifndef REGION_H
#define REGION_H

#include <vector>
#include <list>
using namespace std;

#include "point.h"

class Region
{
 public:
  Region();
  Region( vector<Point> _pts,
          vector<int> _curveIds, vector<bool> _curveOrients );
  ~Region();
  vector<Point> getPoints(){ return m_pts; };
  vector<int> getCurveIds(){ return m_curveIds; };
  vector<bool> getCurveOrients(){ return m_curveOrients; };
  void setCurveIds( vector<int> _curveIds ){ this->m_curveIds = _curveIds; };
  void setCurveOrients( vector<bool> _curveOrients )
                                   { this->m_curveOrients = _curveOrients; };
  void setSelected( bool _select ) { m_selected = _select; };
  bool isSelected() { return m_selected; };
  void getBoundBox( double* _xmin, double* _xmax,
                    double* _ymin, double* _ymax );

 private:
  vector<Point> m_pts;          // boundary points
  vector<int> m_curveIds;       // indexes of region curves
  vector<bool> m_curveOrients;  // orientations of curves with respect to
                                //      counter-clockwise region boundary
  bool m_selected;
};

#endif // REGION_H
