#include "regioncreation.h"

RegionCreation::RegionCreation(QWidget *parent, Qt::WFlags flags)
    : QMainWindow(parent, flags)
{
  ui.setupUi(this);

  // create a model object and store a pointer to it in canvas object
  GeomModel* m = new GeomModel();
  ui.canvas->setModel(m);

  // Set default button checked status
  ui.actionSelect->setChecked(true);
  ui.actionLine->setChecked(false);

  // set default mouse action on canvas
  ui.canvas->setMouseAction( GLPanel::SELECTION );
}

RegionCreation::~RegionCreation()
{
}

void RegionCreation::on_actionSelect_triggered()
{
  ui.actionSelect->setChecked(true);
  ui.actionLine->setChecked(false);
  // set corresponding mouse action on canvas
  ui.canvas->setMouseAction( GLPanel::SELECTION );
}

void RegionCreation::on_actionLine_triggered()
{
  ui.actionSelect->setChecked(false);
  ui.actionLine->setChecked(true);
  // set corresponding mouse action on canvas
  ui.canvas->setMouseAction( GLPanel::COLLECTION );
  ui.canvas->setCurveType( Curve::LINE );
}

void RegionCreation::on_actionDelete_triggered()
{
  ui.canvas->delSelectedEntities();
}

void RegionCreation::on_actionIntersect_triggered()
{
  ui.canvas->intersectTwoSelectedLines();
}

void RegionCreation::on_actionCreateRegion_triggered()
{
  ui.canvas->createRegion();
}

void RegionCreation::on_actionFit_triggered()
{
  ui.canvas->fitWorldToViewport();
}

void RegionCreation::on_actionZoomIn_triggered()
{
  ui.canvas->zoomIn();
}

void RegionCreation::on_actionZoomOut_triggered()
{
  ui.canvas->zoomOut();
}

void RegionCreation::on_actionPanLeft_triggered()
{
  ui.canvas->panLeft();
}

void RegionCreation::on_actionPanRight_triggered()
{
  ui.canvas->panRight();
}

void RegionCreation::on_actionPanDown_triggered()
{
  ui.canvas->panDown();
}

void RegionCreation::on_actionPanUp_triggered()
{
  ui.canvas->panUp();
}
